using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.Common;
using System.Data.SqlClient;
using System.Configuration;
using System.ComponentModel;
using CYQ.Data.SQL;
using CYQ.Data.Cache;
using CYQ.Data.Table;
using CYQ.Data.DAL;

namespace CYQ.Data
{
    /// <summary>
    /// ݲ[ɲ/ͼ]
    /// </summary>
    public class MAction : IDisposable
    {
        #region ȫֱ
        private DbBase _DataSqlHelper;//ݲ
        private CacheManage _SchemaCache;//Cache
        private SQLString _SQLString;
        private MActionUI _UI;
        private MDataRow _Row;//ʾһ
        private Aop.IAop _Aop = new Aop.Aop();//
        /// <summary>
        /// Fill֮󷵻ص
        /// </summary>
        public MDataRow Data
        {
            get
            {
                return _Row;
            }
        }

        private string _TableName; //
        /// <summary>
        /// ǰı
        /// </summary>
        public string TableName
        {
            get
            {
                return _TableName;
            }
            set
            {
                _TableName = value;
            }
        }
        private string _ConnectionString;
        /// <summary>
        /// ǰݿַ
        /// </summary>
        public string ConnectionString
        {
            get
            {
                return _ConnectionString;
            }
            set
            {
                _ConnectionString = value;
            }
        }
        private string debugInfo = string.Empty;
        /// <summary>
        /// Ϣ,sql估
        /// </summary>
        public string DebugInfo
        {
            get
            {
                if (_DataSqlHelper != null)
                {
                    return _DataSqlHelper.attachInfo.ToString();
                }
                return debugInfo;
            }
        }
        /// <summary>
        /// ǰݿ[Access/Mssql/Oracle/SQLite]
        /// </summary>
        public DalType DalType
        {
            get
            {
                return _DataSqlHelper.dalType;
            }
        }
        private bool _IsInsertCommand; //Ƿִв(Update)

        /// <summary>
        /// ֵ,ͨڼ¼
        /// </summary>
        //public int ReturnValue
        //{
        //    get
        //    {
        //        if (_DataSqlHelper != null)
        //        {
        //            return _DataSqlHelper.ReturnValue;
        //        }
        //        else
        //        {
        //            return 0;
        //        }
        //    }
        //}
        #endregion

        #region 캯

        /// <summary>
        /// 캯
        /// </summary>
        /// <param name="tableNamesEnum">/ͼ</param>
        /// <example><code>
        ///     MAction action=new MAction(TableNames.Users);
        ///   MAction action=new MAction("Users");
        ///   MAction action=new MAction("(select m.*,u.UserName from Users u left join Message m on u.ID=m.UserID) v");
        ///   MAction action=new MAction(ViewNames.Users);//ͼ
        /// ݿⷽʽ
        /// MAction action=new MAction(U_DataBaseNameEnum.Users);
        /// ˵Զȡݿ[U_EnumΪǰ׺],ȡݿΪDataBaseNameConn
        /// U_Ϊ V_Ϊͼ P_Ϊ洢
        /// </code></example>
        public MAction(object tableNamesEnum)
        {
            string conn = string.Empty;
            if (tableNamesEnum is Enum)
            {
                string enumName = tableNamesEnum.GetType().Name;
                if (enumName != "TableNames" && enumName != "ViewNames")
                {
                    conn = enumName.Substring(2).Replace("Enum", "Conn");
                }
            }
            Init(tableNamesEnum, conn);
        }
        /// <summary>
        /// 캯2
        /// </summary>
        /// <param name="tableNamesEnum">/ͼ</param>
        /// <param name="conn">web.configµconnectionStringsname,ַ</param>
        /// <example><code>
        ///     MAction action=new MAction(TableNames.Users,"Conn");
        ///   MAction action=new MAction(TableNames.Users,"server=.;database=CYQ;uid=sa;pwd=123456");
        /// </code></example>
        public MAction(object tableNamesEnum, string conn)
        {
            Init(tableNamesEnum, conn);
        }
        #endregion

        #region ʼ
        private void InitSqlHelper(string conn)
        {
            if (_DataSqlHelper == null)
            {
                _DataSqlHelper = DalAction.GetHelper(conn);
                _ConnectionString = _DataSqlHelper.Con.ConnectionString;
            }
        }
        /// <summary>
        /// л,AʱҪB,ҪnewһMAaction,ֱӻñл
        /// </summary>
        /// <param name="tableObj">Ҫлı/ͼ</param>
        /// <example><code>
        ///     MAction action = new MAction(TableNames.Users);
        ///     if (action.Fill("UserName='·'"))
        ///     {
        ///         int id = action.Get&lt;int&gt;(Users.ID);
        ///         if (action.ResetTable(TableNames.Message))
        ///         {
        ///             //Message
        ///             action.Close();
        ///          }
        ///      }
        /// </code></example>
        public bool ResetTable(object tableObj)
        {
            if (tableObj is MDataRow)
            {
                InitRow(tableObj as MDataRow);
            }
            else
            {
                _TableName = tableObj.ToString();
                if (!FillTableSchema())
                {
                    OnError();
                    return false;
                }
            }
            ResetRow();
            return true;
        }
        private void InitRow(MDataRow row)
        {
            _Row = row as MDataRow;
            for (int i = 0; i < _Row.Count; i++)
            {
                _Row[i]._CellValue.IsChange = false;
            }
            _TableName = _Row.TableName;
        }
        private void Init(object tableObj, string conn)
        {
            InitSqlHelper(conn);
            if (tableObj is MDataRow)
            {
                InitRow(tableObj as MDataRow);
            }
            else
            {
                _TableName = tableObj.ToString();
                _Row = new MDataRow();
                _SchemaCache = CacheManage.Instance;
                if (!FillTableSchema())
                {
                    throw new Exception(_DataSqlHelper.dalType + " : check the tablename  (" + TableName + ") is exist?");
                }
            }
            _SQLString = new SQLString(ref _Row, ref _DataSqlHelper);
            _UI = new MActionUI(ref _Row);

            Aop.IAop myAop = _Aop.GetFromConfig();//ͼļԶAop
            if (myAop != null)
            {
                SetAop(myAop);
            }
        }
        private void ResetRow()
        {
            if (_SQLString != null)//лԶʱΪNull
            {
                _SQLString.SetRow(ref _Row);
                _UI._Row = _Row;
            }
        }
        private bool FillTableSchema()
        {
            if (FillSchemaFromCache())
            {
                return true;
            }
            else//Cacheʧ
            {

                try
                {
                    MDataColumn mdcs = null;
                    if (_TableName.IndexOf('(') > -1 && _TableName.IndexOf(')') > -1)//Զtable
                    {
                        _TableName = SQLString.FormatDal(_TableName, _DataSqlHelper.dalType, false);
                        _DataSqlHelper.tempSql = "view";//ʹaccessʽ
                    }
                    mdcs = SchemaAction.GetColumn(_TableName, ref _DataSqlHelper);
                    _Row = ToDataRow(mdcs);
                    _Row.TableName = _TableName;
                    _SchemaCache.Add(_TableName, mdcs.Clone(), null, 1440);
                    return true;

                }
                catch
                {
                    return false;
                }

            }
        }
        private bool FillSchemaFromCache()
        {
            bool returnResult = false;
            if (_SchemaCache != null)
            {
                if (_SchemaCache.Contains(_TableName))
                {
                    try
                    {
                        _Row = ToDataRow(_SchemaCache.Get(_TableName) as MDataColumn);
                        returnResult = _Row.Count > 0;
                    }
                    catch
                    {
                    }
                }
            }
            return returnResult;
        }
        #endregion



        #region ݿ

        private bool InsertOrUpdate(string SqlCommandText)
        {
            bool returnResult = false;
            if (_SQLString._IsCanDo)
            {
                if (_IsInsertCommand) //
                {
                    _IsInsertCommand = false;
                    object ID;
                    switch (_DataSqlHelper.dalType)
                    {
                        case DalType.Sql:
                            ID = _DataSqlHelper.ExeScalar(SqlCommandText, false);
                            break;
                        default:
                            ID = _DataSqlHelper.ExeNonQuery(SqlCommandText, false);
                            if (ID != null && Convert.ToInt32(ID) > 0)
                            {
                                _DataSqlHelper.ClearParameters();
                                ID = _DataSqlHelper.ExeScalar(_SQLString.GetMaxID(), false);
                            }
                            break;
                    }
                    if (ID != null)
                    {
                        returnResult = Fill(ID);
                    }
                }
                else //
                {
                    returnResult = _DataSqlHelper.ExeNonQuery(SqlCommandText, false) > 0;
                }
            }
            if (returnResult)
            {
                _SQLString._IsCanDo = false;
            }
            return returnResult;
        }
        /// <summary>
        ///  
        /// </summary>
        /// <example><code>
        /// MAction action=new MAction(TableNames.Users);
        /// action.Set(Users.Username,"·");
        /// action.Insert();
        /// action.Close();
        /// </code></example>
        public bool Insert()
        {
            return Insert(false);
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="AutoSetValue">ǷԶȡֵ[Զӿؼȡֵ,ҪȵSetAutoPrefixÿؼǰ׺]</param>
        /// <example><code>
        /// MAction action=new MAction(TableNames.Users);
        /// action.SetAutoPrefix("txt","ddl");
        /// action.Insert(true);
        /// action.Close();
        /// </code></example>
        public bool Insert(bool AutoSetValue, params object[] aopInfo)
        {
            _Aop.Begin(Aop.AopEnum.Insert, _TableName, aopInfo);
            if (AutoSetValue)
            {
                _UI.AutoSetColumnValue(true);
            }
            _IsInsertCommand = true;
            _DataSqlHelper.ClearParameters();
            bool result = InsertOrUpdate(_SQLString.GetInsertSql());
            if (!result)
            {
                OnError();
            }
            _Aop.End(Aop.AopEnum.Insert, result, _Row, aopInfo);
            return result;
        }
        /// <summary>
        ///  
        /// </summary>
        /// <param name="where">where,ֱӴidֵ:[88],where:[id=88 and name='·']</param>
        /// <param name="AutoSetValue">ǷԶȡֵ[Զӿؼȡֵ,ҪȵSetAutoPrefixÿؼǰ׺]</param>
        /// <example><code>
        /// MAction action=new MAction(TableNames.Users);
        /// action.SetAutoPrefix("txt","ddl");
        /// action.Update("name='·'",true);
        /// action.Close();
        /// </code></example>
        public bool Update(object where, bool AutoSetValue, params object[] aopInfo)
        {
            _Aop.Begin(Aop.AopEnum.Update, _TableName, aopInfo);
            if (AutoSetValue)
            {
                _UI.AutoSetColumnValue(false);
            }
            if (where == null && _Row[0].Value != null)
            {
                where = _Row[0].Value;
            }
            _DataSqlHelper.ClearParameters();
            string command = _SQLString.GetUpdateSql(where);
            bool result = InsertOrUpdate(command);
            if (!result)
            {
                OnError();
            }
            _Aop.End(Aop.AopEnum.Update, result, _Row, aopInfo);
            return result;
        }
        /// <summary>
        ///  [ĬIDֵ]
        /// </summary>
        /// <example><code>
        /// MAction action=new MAction(TableNames.Users);
        /// action.Set(Users.Username,"·");
        /// action.Set(Users.ID,1);
        /// action.Update();
        /// action.Close();
        /// </code></example>
        public bool Update()
        {
            return Update(_Row[0].Value, false);
        }
        /// <summary>
        ///  
        /// </summary>
        /// <param name="where">where,ֱӴidֵ:[88],where:[id=88 and name='·']</param>
        /// <example><code>
        /// MAction action=new MAction(TableNames.Users);
        /// action.Set(Users.Username,"·");
        /// action.Update("id=1");
        /// action.Close();
        /// </code></example>
        public bool Update(object where)
        {
            return Update(where, false);
        }
        /// <summary>
        ///  ɾ[ĬIDֵ]
        /// </summary>
        public bool Delete()
        {
            return Delete(_Row[0].Value);
        }
        /// <summary>
        ///  ɾ
        /// </summary>
        /// <param name="where">where,ֱӴidֵ:[88],where:[id=88 and name='·']</param>
        public bool Delete(object where, params object[] aopInfo)
        {
            _Aop.Begin(Aop.AopEnum.Delete, _TableName, aopInfo);
            object id = where;
            _DataSqlHelper.ClearParameters();
            int row = _DataSqlHelper.ExeNonQuery(_SQLString.GetDeleteSql(where), false);
            bool result = row > 0;
            if (result)
            {
                return true;
            }
            else
            {
                OnError();
            }
            _Aop.End(Aop.AopEnum.Delete, result, id, aopInfo);
            return result;
        }

        /// <summary>
        /// ѡ
        /// </summary>
        /// <returns></returns>
        public MDataTable Select()
        {
            int count;
            return Select(0, 0, "", out count);
        }
        public MDataTable Select(string where)
        {
            int count;
            return Select(0, 0, where, out count);
        }
        /// <summary>
        /// ֲܵѡ[ѯ,ѡʱֻPageIndex/PageSizeΪ0]
        /// </summary>
        /// <param name="pageIndex">ڼҳ</param>
        /// <param name="pageSize">ÿҳ[Ϊ0ʱĬѡ]</param>
        /// <param name="where"> ѯ[ɸ order by ]</param>
        /// <param name="rowCount">صļ¼</param>
        /// <returns></returns>
        public MDataTable Select(int pageIndex, int pageSize, string where, out int rowCount, params object[] aopInfo)
        {
            _Aop.Begin(Aop.AopEnum.Select, _TableName, aopInfo);
            rowCount = 0;
            MDataTable MTable = null;
            _DataSqlHelper.ClearParameters();
            DbDataReader sdReader = null;
            if (_SQLString != null)
            {
                where = _SQLString.FormatWhere(where);
            }
            else
            {
                where = SQLString.FormatDal(where, _DataSqlHelper.dalType, true);
            }
            switch (_DataSqlHelper.dalType)
            {
                case DalType.Sql:
                    _DataSqlHelper.AddParameters("@PageIndex", pageIndex, DbType.Int32, -1, ParameterDirection.Input);
                    _DataSqlHelper.AddParameters("@PageSize", pageSize, DbType.Int32, -1, ParameterDirection.Input);
                    _DataSqlHelper.AddParameters("@TableName", _SQLString.GetSelectTableName(ref where), DbType.String, -1, ParameterDirection.Input);//ָйܣGetSelectTableName
                    _DataSqlHelper.AddParameters("@Where", where, DbType.String, -1, ParameterDirection.Input);
                    sdReader = _DataSqlHelper.ExeDataReader("SelectBase", true);
                    break;
                case DalType.Access:
                case DalType.SQLite:
                case DalType.MySql:
                    rowCount = GetCount(where);
                    if (rowCount > 0 && (pageIndex - 1) * pageSize < rowCount)
                    {
                        string sql = Pager.GetSql(_DataSqlHelper.dalType, pageIndex, pageSize, where, _TableName, rowCount, _SQLString.GetColumnsSql());
                        sdReader = _DataSqlHelper.ExeDataReader(sql, false);
                    }
                    break;
                case DalType.Oracle:
                    _DataSqlHelper.AddParameters("PageIndex", pageIndex, DbType.Int32, -1, ParameterDirection.Input);
                    _DataSqlHelper.AddParameters("PageSize", pageSize, DbType.Int32, -1, ParameterDirection.Input);
                    _DataSqlHelper.AddParameters("TableName", _SQLString.GetSelectTableName(ref where), DbType.String, -1, ParameterDirection.Input);//ָйܣGetSelectTableName
                    _DataSqlHelper.AddParameters("WhereStr", where, DbType.String, -1, ParameterDirection.Input);
                    sdReader = _DataSqlHelper.ExeDataReader("MyPackage.SelectBase", true);
                    break;
            }
            bool result = false;
            MTable = sdReader;//nullҲҪһnullMDataTable
            if (sdReader != null)
            {
                if (MTable.Columns.Contains("row"))
                {
                    MTable.Columns.Remove("row");
                }
                sdReader.Close();
                result = true;
                switch (_DataSqlHelper.dalType)
                {
                    case DalType.Sql:
                    case DalType.Oracle:
                        rowCount = _DataSqlHelper.ReturnValue;
                        break;
                    //case DalType.Access:
                    //    rowCount = GetCount(where);
                    //    break;
                }
            }
            else
            {
                MTable.LoadRow(_Row);
            }
            _DataSqlHelper.ClearParameters();
            _Aop.End(Aop.AopEnum.Select, result, MTable, aopInfo);
            return MTable;
        }


        /// <summary>
        /// [ѡ]
        /// </summary>
        /// <param name="where">where,ֱӴidֵ:[88],where:[id=88 and name='·']</param>
        /// <example><code>
        /// MAction action=new MAction(TableNames.Users);
        /// if(action.Fill("name='·'")) //action.Fill(888)  action.Fill(id=888)
        /// {
        ///     action.SetTo(labUserName);
        ///     action.Close();
        /// }
        /// </code></example>
        public bool Fill(object where, params object[] aopInfo)
        {
            _Aop.Begin(Aop.AopEnum.Fill, _TableName, aopInfo);
            bool result = false;
            if (_DataSqlHelper != null)
            {
                _DataSqlHelper.ClearParameters();
                MDataTable mTable = _DataSqlHelper.ExeDataReader(_SQLString.GetTopOneSql(where), false);
                result = (mTable != null && mTable.Rows.Count > 0);
                if (result)
                {
                    _Row.LoadValue(mTable.Rows[0]);//ָкз仯LoadValue
                    //_Row = mTable.Rows[0];
                    //_Row.TableName = TableName;
                    //where = _Row[0].Value;
                    //ResetRow();
                }
                else
                {
                    OnError();
                }
            }
            _Aop.End(Aop.AopEnum.Fill, result, _Row, aopInfo);
            return result;
        }
        /// <summary>
        /// ؼ¼
        /// </summary>
        /// <param name="where">where,ֱӴidֵ:[88],where:[id=88 and name='·']</param>
        public int GetCount(string where, params object[] aopInfo)
        {
            _Aop.Begin(Aop.AopEnum.GetCount, _TableName, aopInfo);
            _DataSqlHelper.ClearParameters();
            object count = _DataSqlHelper.ExeScalar(_SQLString.GetCountSql(where), false);
            bool result = (count != null && Convert.ToInt32(count) > 0);
            _Aop.End(Aop.AopEnum.GetCount, result, count, aopInfo);
            return result ? Convert.ToInt32(count) : 0;
        }
        /// <summary>
        /// Ƿָ
        /// </summary>
        /// <param name="where">where,ֱӴidֵ:[88],where:[id=88 and name='·']</param>
        public bool Exists(string where, params object[] aopInfo)
        {
            return GetCount(where, aopInfo) > 0;
        }
        #endregion

        #region 

        /// <summary>
        /// ͷԴ,ͬڵDisponse
        /// </summary>
        public void Close()
        {
            Dispose();
            if (_Aop != null)
            {
                _Aop = null;
            }
        }
        #region UI

        /// <summary>
        /// ֵõؼ
        /// </summary>
        /// <param name="control">ؼ,Ŀǰ֧Ϊ[TextBox/Literal/Label/HiddenField/DropDownList/CheckBox]</param>
        /// <param name="value">Զֵ,ֵڣ򲻴ӿؼлȡֵ</param>
        /// <param name="isControlEnabled">ؼǷ</param>
        /// <example><code>
        /// ʾ1action.SetTo(txtUserName,"·",true);//ͬڣtxtUserName.Text="·";txtUserName.IsEnabled=true;
        /// ʾ2action.SetTo(txtUserName,null,false);//ͬڣtxtUserName.Text=action.Get&lt;string&gt;(Users.UserName);txtUserName.IsEnabled=false;
        /// </code></example>
        public void SetTo(object control, object value, bool isControlEnabled)
        {
            _UI.Set(control, value, isControlEnabled);
        }
        /// <summary>
        /// ֵõؼ
        /// </summary>
        /// <param name="control">ؼ,Ŀǰ֧Ϊ[TextBox/Literal/Label/HiddenField/DropDownList/CheckBox]</param>
        /// <param name="value">Զֵ,ֵڣ򲻴ӿؼлȡֵ</param>
        /// <example><code>
        /// ʾ1action.SetTo(txtUserName,"·",true);//ͬڣtxtUserName.Text="·";
        /// ʾ2action.SetTo(txtUserName,null);//ͬڣtxtUserName.Text=action.Get&lt;string&gt;(Users.UserName);
        /// </code></example>
        public void SetTo(object control, object value)
        {
            _UI.Set(control, value, true);
        }
        /// <summary>
        /// ֵõؼ
        /// </summary>
        /// <param name="control">ؼ,Ŀǰ֧Ϊ[TextBox/Literal/Label/HiddenField/DropDownList/CheckBox]</param>
        /// <example><code>
        /// ʾaction.SetTo(txtUserName);//ͬڣtxtUserName.Text=action.Get&lt;string&gt;(Users.UserName);
        /// </code></example>
        public void SetTo(object control)
        {
            _UI.Set(control, null, true);
        }
        /// <summary>
        /// ؼֵõʵ[ĬϴӿؼԶȡֵ]
        /// </summary>
        /// <param name="control">ؼ,Ŀǰ֧Ϊ[TextBox/Literal/Label/HiddenField/DropDownList/CheckBox]</param>
        /// <param name="value">Զֵ,ֵڣ򲻴ӿؼлȡֵ</param>
        /// <example><code>
        /// ʾ1action.GetFrom(txtUserName,"·");//Զֵ·족UserName
        /// ʾ2action.GetFrom(txtUserName,null);//txtUserName.TextֵUserName
        /// </code></example>
        public void GetFrom(object control, object value)
        {
            _UI.Get(control, value);
        }
        /// <summary>
        /// ؼֵõʵ[ĬϴӿؼԶȡֵ]
        /// </summary>
        /// <param name="control">ؼ,Ŀǰ֧Ϊ[TextBox/Literal/Label/HiddenField/DropDownList/CheckBox]</param>
        /// <example><code>
        /// ʾaction.GetFrom(txtUserName);//txtUserName.TextֵUserName
        /// </code></example>
        public void GetFrom(object control)
        {
            _UI.Get(control, null);
        }
        /// <summary>
        /// JsonַԶֵ,json:{"Name":"cyqdata","Url":"www.cyqdata.com"}
        /// </summary>
        /// <param name="json"></param>
        public void GetFromJson(string json)
        {
            Dictionary<string, string> dic = JsonHelper.Split(json);
            if (dic != null && dic.Count > 0)
            {
                foreach (KeyValuePair<string, string> item in dic)
                {
                    _Row.Set(item.Key, item.Value);
                }
            }
        }
        public MAction Bind(object control)
        {
            return Bind(control, string.Empty, MBindUI.GetID(control).Substring(3), "ID");
        }
        public MAction Bind(object control, string where)
        {
            return Bind(control, where, MBindUI.GetID(control).Substring(3), "ID");
        }
        /// <summary>
        /// б,ؼҪ̳ԣListControl
        /// </summary>
        /// <param name="control">DropDown/CheckBoxList/RadioButtonList</param>
        /// <param name="where">Աݽй:"ID>15 and Url='cyqdata.com'"</param>
        /// <param name="text">ʱʾֶ[ĬֶȡԿؼID(ȥǰĸǰ׺)]</param>
        /// <param name="value">ʱʾֶζӦֵ[ĬֵֶΪ:ID]</param>
        public MAction Bind(object control, string where, object text, object value)
        {
            MDataTable mTable = _DataSqlHelper.ExeDataReader(_SQLString.GetBindSql(where, text, value), false);
            bool result = (mTable != null && mTable.Rows.Count > 0);
            if (result)
            {
                MBindUI.BindList(control, mTable);
            }
            return this;
        }
        #endregion

        /// <summary>
        /// ȡֵ
        /// </summary>
        public T Get<T>(object key)
        {
            return _Row.Get<T>(key);
        }
        /// <summary>
        /// ֵ,:[action.Set(TableName.ID,10);]
        /// </summary>
        /// <param name="key">ֶ,ö:[TableName.ID]</param>
        /// <param name="value">Ҫøֶεֵ</param>
        /// <example><code>
        /// setʾaction.Set(Users.UserName,"·");
        /// getʾint id=action.Get&lt;int&gt;(Users.ID);
        /// </code></example>
        public void Set(object key, object value)
        {
            _Row[key].Value = value;
        }
        /// <summary>
        /// Զǰ׺,ɴǰ׺[1]
        /// </summary>
        /// <param name="autoPrefix">һǰ׺[]</param>
        /// <param name="otherPrefix">Nǰ׺[ѡ]</param>
        public void SetAutoPrefix(string autoPrefix, params string[] otherPrefix)
        {
            _UI.SetAutoPrefix(autoPrefix, otherPrefix);
        }

        /// <summary>
        /// òѯָ[úʹFillSelect]
        /// ʾҳѯʱбָѡ
        /// </summary>
        /// <param name="columnNames">ö[FillSelect,]</param>
        public void SetSelectColumns(params object[] columnNames)
        {
            _SQLString._SelectColumns = columnNames;
        }


        #region 
        /// <summary>
        /// 񼶱
        /// </summary>
        /// <param name="level"></param>
        public void SetTransLevel(IsolationLevel level)
        {
            _DataSqlHelper.tranLevel = level;
        }
        /// <summary>
        /// ¿[ڵEndTransation¿]
        /// </summary>
        public void ReOpenTransation()
        {
            _DataSqlHelper.openTrans = true;
        }
        /// <summary>
        /// ʼ
        /// </summary>
        public void BeginTransation()
        {
            _DataSqlHelper.openTrans = true;
        }
        /// <summary>
        /// ύ[ĬϿ,ֱClose/Disponseʱύ]
        /// Ҫǰ,ɵô˷
        /// </summary>
        public void EndTransation()
        {
            if (_DataSqlHelper != null && _DataSqlHelper.openTrans)
            {
                _DataSqlHelper.EndTransaction();
            }
        }
        /// <summary>
        /// ع
        /// </summary>
        public void RollBack()
        {
            if (_DataSqlHelper != null && _DataSqlHelper.openTrans)
            {
                _DataSqlHelper.RollBack();
            }
        }
        #endregion

        #region Aop


        /// <summary>
        /// ȡAopAopģʹMActionʱ
        /// </summary>
        public void SetNoAop()
        {
            _Aop = new Aop.Aop();
        }
        /// <summary>
        /// עAopһ²Ҫõ
        /// </summary>
        /// <param name="aop"></param>
        public void SetAop(Aop.IAop aop)
        {
            _Aop = aop;
            _DataSqlHelper.OnExceptionEvent += new DbBase.OnException(_DataSqlHelper_OnExceptionEvent);
        }

        void _DataSqlHelper_OnExceptionEvent(string msg)
        {
            _Aop.OnError(msg);
        }
        #endregion

        //public void FormatAllInputValue(string format)
        //{
        //    ValueFormat.IsFormat = true;
        //    ValueFormat.formatString = format;
        //}
        //public void EndFormat()
        //{
        //    ValueFormat.Reset();
        //}
        #endregion


        #region IDisposable Ա
        /// <summary>
        /// ͷԴ
        /// </summary>
        public void Dispose()
        {
            //EndFormat();
            if (_DataSqlHelper != null)
            {
                //if (_Row != null)
                //{
                //    _Row.Clear();
                //    _Row = null;
                //}
                _DataSqlHelper.Dispose();
                if (_DataSqlHelper != null)
                {
                    debugInfo += _DataSqlHelper.attachInfo;
                    _DataSqlHelper = null;
                }
                if (_SQLString != null)
                {
                    _SQLString = null;
                }
                if (_UI != null)
                {
                    _UI.Dispose();
                }
            }
        }
        internal void OnError()
        {
            if (_DataSqlHelper != null && _DataSqlHelper.openTrans)
            {
                Dispose();
            }
        }
        #endregion

        #region ICloneable Ա
        internal MDataRow ToDataRow(MDataColumn mdcs)
        {
            MDataRow dataRecord = new MDataRow();

            for (int i = 0; i < mdcs.Count; i++)
            {
                CellStruct mcb = mdcs[i];
                MDataCell mdc = new MDataCell(ref mcb);
                dataRecord.Add(mdc);
            }
            dataRecord.TableName = this._TableName;

            return dataRecord;
        }

        #endregion
    }


}
