using System;
using System.Collections.Generic;
using System.Text;
using System.Web.Caching;

namespace CYQ.Data.Cache
{

    public class CacheCell
    {
        string _Key;//keyֵ
        string _FilePath;//ļ·
        public List<long> TimeTicks;//¼ûÿηʵʱб

        public void RemoverTicks(long timeTicks)//ɾڵʱ¼,timeTicksʱڵļ¼
        {
            int count = TimeTicks.Count;//ʱ
            if (count > 0)
            {
                long[] tempTimeTickValuesList = new long[count];//ʱ洢ɾTimeTickֵ
                for (int i = 0; i < count; i++)
                {
                    if ((DateTime.Now.Ticks - TimeTicks[i]) > timeTicks)//ȡɾtimeTicksļ¼
                    {
                       tempTimeTickValuesList[i]=TimeTicks[i];
                    }
                }
                for (int j = 0; j < tempTimeTickValuesList.Length; j++)//ɾtimeTicksʱ֮ļ¼
                {
                    TimeTicks.Remove(tempTimeTickValuesList[j]);
                }
                tempTimeTickValuesList = null;
                
            }
        }
        public long LiftTime//CacheĿ¼,Cacheӵһα浽һαõʱ
        {
            get
            {
                return TimeTicks[TimeTicks.Count - 1] - TimeTicks[0];
            }
        }
        public string FilePath//CacheĹļ·
        {
            get
            {
                return _FilePath;
            }
        }
        public string Key//CacheӦֵ
        {
            get
            {
                return _Key;
            }
        }
        public CacheCell(string Key,string FilePath)
        {
            this._Key = Key;
            this._FilePath = FilePath;
            TimeTicks = new List<long>();
        }
        public CacheCell(){}
    }
    /// <summary>
    /// ģʽ[ӳټ]
    /// Cacheֵ仺б,ձʽΪ<key,<key,value>>
    /// </summary>
    internal class CacheCellList : System.Collections.Generic.Dictionary<string, CacheCell>, System.Collections.Generic.IDictionary<string, CacheCell>
    {
        private System.Collections.Generic.List<string> _Key;//keyֵ
        public System.Collections.Generic.List<string> KeyList //Keyֵб
        {
            get
            {
                return _Key;
            }
            set
            {
                if (value==null)
                {
                    _Key.Clear();
                }
            }
        }

        public static CacheCellList Instance
        {
            get
            {
                return Shell.instance;
            }
        }
 

        private CacheCellList()
        {
            if (this._Key != null)
            {
                this._Key.Clear();
            }
            _Key = new List<string>();
        }

        #region IDictionary<string,CacheCell> Ա

        public new void Add(string key, CacheCell value)
        {
            _Key.Add(key);
            base.Add(key, value);
        }

        public new bool ContainsKey(string key)
        {
           return base.ContainsKey(key);
        }

        public new ICollection<string> Keys
        {
            get
            {
                return base.Keys;
            }
        }

        public new void Remove(string key)
        {
            _Key.Remove(key);
            base.Remove(key);
        }


        public new ICollection<CacheCell> Values
        {
            get
            {
                return base.Values;
            }
        }

        public new CacheCell this[string key]
        {
            get
            {
                return base[key];
            }
            set
            {
                base[key] = value;
            }
        }

        #endregion

        class Shell
        {
            internal static readonly CacheCellList instance = new CacheCellList();
        }
    }
 
 
    
    public class CacheManage
    {
        #region 
        private readonly long UnJoinSortTimeTick =100000000;// 3000000000;//18000000000;//ݶСʱ
        private readonly long CacheMaxCount = 1000;
        private readonly int CacheFullPercent = 99;//ٽ[ǷN%]
        private readonly int CacheClearPercent = 20;//ٽ[ǷN%]
        //ȼ
        private readonly int CacheLowPriorityCount = 1;
        private readonly int CacheBelowNormalPriorityCount = 10;
        private readonly int CacheNormalPriorityCount = 50;
        private readonly int CacheAboveNormalPriorityCount = 100;
        private readonly int CacheHighPriorityCount = 500;
        private readonly System.Web.HttpContext H =  new System.Web.HttpContext(new System.Web.HttpRequest("Null.File", "http://CYQ.Data.org", String.Empty), new System.Web.HttpResponse(null));
        #endregion

        protected CacheCell theGetCacheCell ;//Ԥ建嵥Ԫ[GetCacheƵ,ϵNewٶ̫CPUԴ,ȶ]
        protected System.Web.Caching.Cache theCache = null;
        private CacheCellList indexKey ;//CacheͬĻֵ伯

        private System.Threading.Thread DoWorkDelegate; 
   

        private CacheManage()
        { 
            theCache = H.Cache;
            theGetCacheCell = new CacheCell();
            indexKey = CacheCellList.Instance;
 

            DoWorkDelegate = new System.Threading.Thread(new System.Threading.ThreadStart(ClearCacheWork.Do));
            DoWorkDelegate.Start();
        }
        /// <summary>
        /// Cache,CacheΪnullʱ0
        /// </summary>
        public int Count
        {
            get
            {
                if (theCache == null)
                    return 0;
                else
                return theCache.Count;
            }
        }
        
        public static CacheManage Instance
        {
            get
            {
                return Shell.instance;
            }
        }

        class Shell
        {
            internal static readonly CacheManage instance = new CacheManage();
        }

        class ClearCacheWork
        {
            public static void Do()
            {
                while (true)
                {
                    Work();
                    System.Threading.Thread.Sleep(6000);
                }
            }
            
            private static void Work()
            {
                
                if (CacheManage.Instance.IsFullCache(CacheManage.Instance.CacheFullPercent))
                {
                    CacheManage.Instance.DeleteByPriority(CacheManage.Instance.CacheClearPercent);
                }
                CacheManage.Instance.UpdateAllCacheCellTickTime(CacheManage.Instance.UnJoinSortTimeTick);
            }

        }
        
        /// <summary>
        /// һCache
        /// </summary>
        /// <param name="key">ʶ</param>
        /// <returns></returns>
        public object GetCache(string key)
        {
            if (theCache != null && theCache.Count>0)
            {
                if (theCache[key] == null)
                {
                    return null;
                }
                else
                {
                    //ȸ»浥Ԫļ
                    theGetCacheCell = indexKey[key] as CacheCell;//ȡ浥Ԫ
                    theGetCacheCell.TimeTicks.Add(DateTime.Now.Ticks);
                    indexKey[key] = theGetCacheCell;
                    //֮󷵻cache 
                    return theCache[key];
                }
            }
            else
            {
                return null;
            }
        }

        public bool ContainsValue(string key)
        {
            if (theCache != null)
            {
                if (theCache[key] == null)
                {
                    if (indexKey.ContainsKey(key))
                    {
                        indexKey.Remove(key);
                    }
                    return false;
                }
                else
                {
                    return true;
                }
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// û汻Ĵ
        /// </summary>
        /// <returns></returns>
        public int GetCalledCount(string key)
        {
            if (theCache != null)
            {
               return ((CacheCell)indexKey[key]).TimeTicks.Count;//ӻ浥Ԫлü
            }
            else
            {
                return 0;
            }

        }
        /// <summary>
        /// һ浥ԪCacheȼ[˵,ϵͳԴȼֻΪ޲,ʵʵȼǸݷķΧȡ!]
        /// </summary>
        /// <param name="key"></param>
        /// <returns></returns>
        public CacheItemPriority GetPriority(string key)
        {
            CacheCell CacheCellObject = (CacheCell)indexKey[key];//ȡһ浥Ԫ
            if (CacheCellObject != null)
            {
                if (CacheCellObject.LiftTime < UnJoinSortTimeTick)//ݶСʱ
                {
                    return CacheItemPriority.Default;//СʱڵĲμȼ,ĬΪ
                }
                else
                {
                    return GetItemPriority(CacheCellObject.TimeTicks.Count);//ɼȼ
                }
            }
            else
            {
                return CacheItemPriority.Low;//cacheΪnullʱ.򷵻زnullֵ,ͼ????
            }
        }
        /// <summary>
        /// һCache
        /// </summary>
        /// <param name="key">ʶ</param>
        /// <param name="value">ֵ</param>
        /// <param name="filePath">ļ·</param>
        public bool Add(string key, object value, string filePath)
        {
          return  Add(key, value, filePath, CacheItemPriority.Default);
        }
        public bool Add(string key, object value, string filePath, CacheItemPriority CachePriority)
        {
            if (ContainsValue(key))
            {
                return false;
            }
            else
            {
                CacheItemPriority CIPriority;
                SetCacheCell(key, filePath, null, out CIPriority);//û浥Ԫ
                if (CachePriority != CacheItemPriority.Default)
                {
                    CIPriority = CachePriority;
                }
                Insert(key, value, filePath, CIPriority);//ٲCache
                return true;
            }
        }
        /// <summary>
        /// ԵײCacheӷ,һCacheAdd
        /// </summary>
        /// <param name="key">ʶ</param>
        /// <param name="value">ֵ</param>
        /// <param name="filePath">ļ·</param>
        /// <param name="PageVisitCount">һʱҳʴ</param>
        private void Insert(string key, object value, string filePath, CacheItemPriority CIPriority)
        {
            
            if(theCache==null)
            {
                theCache =System.Web.HttpContext.Current.Cache;
            }
            CacheDependency theCacheDependency;
            if (string.IsNullOrEmpty(filePath))
            {
                theCacheDependency = null;
            }
            else
            {
                theCacheDependency = new CacheDependency(filePath);
            }
            if (!IsFullCache(CacheFullPercent))//ǷN%
            {
                theCache.Insert(key, value, theCacheDependency, System.Web.Caching.Cache.NoAbsoluteExpiration, System.Web.Caching.Cache.NoSlidingExpiration, CIPriority, null);
            }
        }
        private bool IsFullCache(float percent)
        {
            long cacheMaxCount = CacheMaxCount;
            if (Convert.ToInt32((cacheMaxCount * percent) / 100) < theCache.Count)
            {
                return true;//N%
            }
            else
            {
                return false;//δN%
            }
        }
        /// <summary>
        /// û嵥Ԫ,ϵͳԶ
        /// </summary>
        /// <param name="key"></param>
        /// <param name="filePath"></param>
        /// <param name="cc"></param>
        /// <param name="PageVisitCount"></param>
        private void SetCacheCell(string key, string filePath, CacheCell cc, out CacheItemPriority CIPriority)
        {
            CacheCell CacheCellObject;
            if (cc == null)//Cacheʱ
            {
                CacheCellObject = new CacheCell(key,filePath);
                CacheCellObject.TimeTicks.Add(DateTime.Now.Ticks);
            }
            else //Cacheʱ
            {
                CacheCellObject = cc;
            }
            if (CacheCellObject.LiftTime < UnJoinSortTimeTick)//Сʱ
            {
                CIPriority = CacheItemPriority.Default;
            }
            else
            {
                CIPriority=GetItemPriority(CacheCellObject.TimeTicks.Count);
            }
            indexKey.Add(key,CacheCellObject);
        }

        /// <summary>
        /// һٷֱCache[ȼǸݷ,ǵϵͳԴȼõ]
        /// </summary>
        /// <param name="percent"></param>
        public void DeleteByPriority(float percent)
        {
            long cacheMaxCount = CacheMaxCount;//cache
            long removeCount = Convert.ToInt32((cacheMaxCount * percent) / 100);//ɾ[ͨٷֱ]
            long count = indexKey.KeyList.Count;//Ŀǰ˶Ŀ
            if (count < removeCount)
            {
                removeCount = count;
            }
            //ͼCache,ɾĵһĿ
            long lowCacheCount = 0;//䵱
            string[] lowCacheKey = new string[removeCount];//ͼCache,ڼ¼ǰremoveCountͼĻKeyֵ

            //ڶͼCache,ɾĵڶĿ
            long belowNormalCacheCount = 0;//䵱
            string[] belowNormalCacheKey = new string[removeCount];//ڶͼCache,ڼ¼ǰremoveCountڶͼĻKeyֵ

            //ͼCache,ɾĵĿ
            long normalCacheCount = 0;//䵱
            string[] normalCacheKey = new string[removeCount];//ͼCache,ڼ¼ǰremoveCountͼĻKeyֵ

            //ȡҪɾCache
            string tempKey = string.Empty;//ʱKeyֵ
            for (int i = 0; i < count; i++)
            {
                if (lowCacheCount >= removeCount)//һɾĿװ,˳
                {
                    break;
                }
                else
                {
                    tempKey = indexKey.KeyList[i];
                    switch (GetPriority(tempKey))//ݲͬȼװͬ
                    {
                        case CacheItemPriority.Low:
                            lowCacheKey[lowCacheCount] = tempKey;//װ
                            lowCacheCount++;//+1
                            break;
                        case CacheItemPriority.BelowNormal:
                            if (belowNormalCacheCount < removeCount)//δʱ
                            {
                                belowNormalCacheKey[belowNormalCacheCount] = tempKey;
                                belowNormalCacheCount++;
                            }
                            break;
                        case CacheItemPriority.Normal:
                            if (normalCacheCount < removeCount)//δʱ
                            {
                                normalCacheKey[normalCacheCount] = tempKey;
                                normalCacheCount++;
                            }
                            break;
                        default:
                            break;
                    }
                }
            }
            //濪ʼɾ
            if (lowCacheCount > 0)//ɾһɾĿ[ͼ]
            {
                for (int df = 0; df < lowCacheCount; df++)//[dfdeleteFirstʶ]
                {
                    Clear(lowCacheKey[df]);
                }
            }
            long leftRemovedCount = removeCount - lowCacheCount;//жǽɾ,ʣɾ
            long tempCount = belowNormalCacheCount;
            if (leftRemovedCount > 0)//ɾڶɾĿ
            {
                if (belowNormalCacheCount > leftRemovedCount)
                {
                    tempCount = leftRemovedCount;
                }
                for (int ds = 0; ds < tempCount; ds++)//ڶɾĿ
                {
                    Clear(belowNormalCacheKey[ds]);
                }
                leftRemovedCount = leftRemovedCount - tempCount;//㻹жǽɾ,ʣɾ
            }
            if (leftRemovedCount > 0)//ɾɾĿ
            {
                tempCount = normalCacheCount;
                if (normalCacheCount > leftRemovedCount)
                {
                    tempCount = leftRemovedCount;
                }
                for (int dt = 0; dt < tempCount; dt++)//ڶɾĿ
                {
                    Clear(normalCacheKey[dt]);
                }
            }
            lowCacheKey = null;
            belowNormalCacheKey = null;
            normalCacheKey = null;
        }
        /// <summary>
        /// ɾһCache
        /// </summary>
        /// <param name="key">ʶ</param>
        public bool Clear(string key)
        {
            bool result = false;
            if (theCache != null)
            {
                if (theCache[key] != null)
                {
                    theCache.Remove(key);
                    if (indexKey.ContainsKey(key))
                    {
                        indexKey.Remove(key);
                        result = true;
                    }
                }
            }
            if (theCache.Count == 0)
            {
                theCache = null;
            }
            return result;
        }
        /// <summary>
        /// ɾҳСָCache
        /// </summary>
        /// <param name="minPageVisitCount"></param>
        public bool Clear(int minPageVisitCount)
        {
            try
            {
                CacheCell CacheCellObject;
                if (theCache != null)
                {
                    string key = string.Empty;
                    int count = indexKey.KeyList.Count;
                    for (int i = 0; i < count; i++)
                    {
                        key = indexKey.KeyList[i];
                        CacheCellObject = (CacheCell)indexKey[key];
                        if (CacheCellObject.TimeTicks.Count <= minPageVisitCount)
                        {
                            Clear(key);
                        }
                    }
                }
                return true;
            }
            catch
            {
                return false;
            }
        }
        /// <summary>
        /// л
        /// </summary>
        public bool ClearAll()
        {
            try
            {
                if (theCache != null)
                {
                    int count = indexKey.KeyList.Count;
                    for (int i = 0; i < count; i++)
                    {
                        theCache.Remove(indexKey.KeyList[i]);
                    }
                    theCache = null;
                    indexKey.KeyList = null;
                    indexKey.Clear();
                }
                return true;
            }
            catch
            {
                return false;
            }
        }
        /// <summary>
        /// ָCacheCellĵԪʱ[ҳʴ]
        /// </summary>
        /// <param name="key"></param>
        /// <param name="timeTicks"></param>
        public void UpdateCacheCellTickTime(string key,long timeTicks)
        {
            CacheCell CacheCellObject;
            if (indexKey[key]!= null)
            {
                CacheCellObject = (CacheCell)indexKey[key];
                CacheCellObject.RemoverTicks(timeTicks);
                indexKey[key] = CacheCellObject;
            }
        }
        /// <summary>
        /// еCacheCellĵԪʱ[ҳʴ]
        /// </summary>
        /// <param name="timeTicks"></param>
        public void UpdateAllCacheCellTickTime(long timeTicks)
        {
            int count = indexKey.KeyList.Count;
            for (int i = 0; i < count; i++)
            {
                UpdateCacheCellTickTime(indexKey.KeyList[i], timeTicks);
            }
        }
        /// <summary>
        /// һȼ[Ŀǰƺʧȥ:ԭǲϵͳȼԶջ.]
        /// </summary>
        /// <param name="key">ʶ</param>
        public void Update(string key)
        {
            string filePath = string.Empty;
            CacheItemPriority CIPriority;
            if (IsAllowUpdate(key,out  filePath))
            {
                object tempObj = theCache[key];
                CacheCell theCachCell = (CacheCell)indexKey[key];
                Clear(key);

                SetCacheCell(key, filePath, theCachCell, out CIPriority);
                Insert(key, tempObj, filePath, CIPriority);
                tempObj = null;
            }
        }
        /// <summary>
        /// ȼǷ˸ı
        /// </summary>
        /// <param name="Key"></param>
        /// <param name="filePath"></param>
        /// <returns></returns>
        private bool IsAllowUpdate(string Key,out string filePath)
        {
            if (indexKey != null && indexKey.ContainsKey(Key))
            {
                  CacheCell cc=(CacheCell)indexKey[Key];
                  filePath = cc.FilePath;
                  return true;
            }
            else
            {
                filePath = string.Empty;
                return false;
            }
        }
        /// <summary>
        /// ҳȼ
        /// </summary>
        /// <param name="PageVisitCount"></param>
        /// <returns></returns>
        private CacheItemPriority GetItemPriority(int PageVisitCount)
        {
            if (0 < PageVisitCount && PageVisitCount < CacheLowPriorityCount)
                return CacheItemPriority.Low;
            else if (CacheLowPriorityCount < PageVisitCount && PageVisitCount < CacheBelowNormalPriorityCount)
                return CacheItemPriority.BelowNormal;
            else if (CacheBelowNormalPriorityCount < PageVisitCount && PageVisitCount < CacheNormalPriorityCount)
                return CacheItemPriority.Normal;
            else if (CacheNormalPriorityCount < PageVisitCount && PageVisitCount < CacheAboveNormalPriorityCount)
                return CacheItemPriority.AboveNormal;
            else if (CacheAboveNormalPriorityCount < PageVisitCount && PageVisitCount < CacheHighPriorityCount)
                return CacheItemPriority.High;
            else
                return CacheItemPriority.NotRemovable;
        }
    }
}
