using System;
using System.Collections.Generic;
using System.Text;
using System.Configuration;

namespace CYQ.Data.DAL
{
    /// <summary>
    /// ݿͲ
    /// </summary>
    internal class DalAction
    {
        public const string SqlClient = "System.Data.SqlClient";
        public const string OleDb = "System.Data.OleDb";
        public const string OracleClient = "System.Data.OracleClient";
        public const string SQLiteClient = "System.Data.SQLite";
        public const string MySqlClient = "MySql.Data.MySqlClient";
        public const string XHtmlClient = "CYQ.Data.XHtmlClient";
        public static DbBase GetHelper(string conn)
        {
            string providerName = "";
            if (conn.Length < 32)
            {
                conn = conn.Length < 1 ? "Conn" : conn;
                if (ConfigurationManager.ConnectionStrings[conn] != null)
                {
                    providerName = ConfigurationManager.ConnectionStrings[conn].ProviderName;
                    conn = ConfigurationManager.ConnectionStrings[conn].ConnectionString;
                }
                else
                {
                    throw new Exception(string.Format("Can't fine the connection key '{0}' from web.config!", conn));
                }
            }
            conn = string.Format(conn, AppDomain.CurrentDomain.BaseDirectory);
            if (string.IsNullOrEmpty(providerName))
            {
                providerName = DalAction.GetpPovider(conn);
            }
            switch (providerName)
            {
                case SqlClient:
                    return new SQLHelper(conn, providerName);
                case OleDb:
                    return new OleHelper(conn, providerName);
                case OracleClient:
                    return new OracleHelper(conn, providerName);
                case SQLiteClient:
                    return new SQLiteHelper(conn, providerName);
                case MySqlClient:
                    return new MySQLHelper(conn, providerName);
            }
            throw new Exception(string.Format("GetHelper:{0} No Be Support Now!", providerName));
        }

        public static string GetpPovider(string conn)
        {
            conn = conn.ToLower();
            if (conn.Contains("microsoft.jet.oledb.4.0") || conn.Contains("microsoft.ace.oledb"))
            {
                return OleDb;
            }
            else if (conn.Contains("provider=msdaora") || conn.Contains("provider=oraoledb.oracle"))
            {
                return OracleClient;
            }
            else if (conn.Contains("failifmissing="))
            {
                return SQLiteClient;
            }
            else if (conn.Contains("host="))
            {
                return MySqlClient;
            }
            else
            {
                return SqlClient;
            }
        }
        public static DalType GetDalType(string providerName)
        {
            switch (providerName)
            {
                case SqlClient:
                    return DalType.Sql;
                case OleDb:
                    return DalType.Access;
                case OracleClient:
                    return DalType.Oracle;
                case SQLiteClient:
                    return DalType.SQLite;
                case MySqlClient:
                    return DalType.MySql;
            }
            throw new Exception(string.Format("GetDalType:{0} No Be Support Now!", providerName));
        }
    }
    /// <summary>
    /// ݿ
    /// </summary>
    public enum DalType
    {
        /// <summary>
        /// MSSQL[2000/2005/2008]
        /// </summary>
        Sql,
        Access,
        Oracle,
        MySql,
        SQLite,
        /// <summary>
        /// No Support Now
        /// </summary>
        FireBird,
        /// <summary>
        /// No Support Now
        /// </summary>
        PostgreSQL
    }
    /// <summary>
    /// ڶݿݵ滻ؼ/
    /// </summary>
    public class DalValue
    {
        /// <summary>
        /// Bit[/] ͵
        /// </summary>
        public const string Desc = "[#DESC]";
        public const string Asc = "[#ASC]";
        /// <summary>
        /// Bit[/] ֵ
        /// </summary>
        public const string True = "[#TRUE]";
        public const string False = "[#FALSE]";
        public const string Len = "[#LEN]";//length
        public const string Substring = "[#SUBSTRING]";//substr
        public const string GetDate = "[#GETDATE]";//length
        public const string Year = "[#YEAR]";//length
        public const string Month = "[#MONTH]";//length
        public const string Day = "[#DAY]";//length
        public const string CharIndex = "[#CHARINDEX]";
        public const string DateDiff = "[#DATEDIFF]";
        public const string Case = "[#CASE]";//֧
        public const string CaseWhen = "[#CASE#WHEN]";//֧
    }
}
