﻿using System.Data;
using System.Data.Common;
using CYQ.Data.Cache;
using System.Reflection;
namespace CYQ.Data.DAL
{
    internal class MySQLHelper : DbBase
    {
        private CacheManage _Cache = CacheManage.Instance;//Cache操作
        public MySQLHelper(string conn, string providerName)
            : base(conn, providerName)
        {
            
        }
        public override void AddReturnPara()
        {

        }
        private Assembly GetAssembly()
        {
            object ass = _Cache.Get("MySqlClient_Assembly");
            if (ass == null)
            {
                try
                {
                    ass = Assembly.Load("MySql.Data");
                    _Cache.Add("MySqlClient_Assembly", ass, null, 10080);
                }
                catch
                {
                    throw new System.Exception("No fine the  MySql.Data.dll");
                }
            }
            return ass as Assembly;
        }
        protected override DbProviderFactory GetFactory(string providerName)
        {
            object factory = _Cache.Get("MySqlClient_Factory");
            if (factory == null)
            {
                Assembly ass = GetAssembly();
                factory = ass.CreateInstance("MySql.Data.MySqlClient.MySqlClientFactory");
                if (factory == null)
                {
                    throw new System.Exception("Can't Create  MySqlClientFactory in MySql.Data.dll");
                }
                else
                {
                    _Cache.Add("MySqlClient_Factory", factory, null, 10080);
                }

            }
            return factory as DbProviderFactory;

        }
        public override DbParameter GetNewParameter()
        {
            Assembly ass = GetAssembly();
            object para = ass.CreateInstance("MySql.Data.MySqlClient.MySqlParameter");
            if (para == null)
            {
                throw new System.Exception("Can't Create  MySqlParameter in MySql.Data.dll");
            }
            else
            {
                return para as DbParameter;
            }
            //object para = _Cache.Get("MySqlClient_Parameter");
            //if (para == null)
            //{
            //    Assembly ass = GetAssembly();
            //    para = ass.CreateInstance("MySql.Data.MySqlClient.MySqlParameter");
            //    if (para == null)
            //    {
            //        throw new System.Exception("Can't Create  MySqlParameter in MySql.Data.dll");
            //    }
            //    else
            //    {
            //        _Cache.Add("MySqlClient_Parameter", para, null, 10080);
            //    }
            //}
            //return para as DbParameter;

        }
        public override string Pre
        {
            get
            {
                return "?";
            }
        }
    }
}
