﻿using System.Data;
using System.Data.Common;
using CYQ.Data.Cache;
using System.Reflection;
namespace CYQ.Data.DAL
{
    internal class SQLiteHelper : DbBase
    {
        private CacheManage _Cache = CacheManage.Instance;//Cache操作
        public SQLiteHelper(string conn, string providerName)
            : base(conn, providerName)
        {
            
        }
        public override void AddReturnPara()
        {

        }
        private Assembly GetAssembly()
        {
            object ass = _Cache.Get("SQLite_Assembly");
            if (ass == null)
            {
                try
                {
                    ass = Assembly.Load("System.Data.SQLite");
                    _Cache.Add("SQLite_Assembly", ass, null, 10080);
                }
                catch
                {
                    throw new System.Exception("No fine the  System.Data.SQLite.dll");
                }
            }
            return ass as Assembly;
        }
        protected override DbProviderFactory GetFactory(string providerName)
        {
            object factory = _Cache.Get("SQLite_Factory");
            if (factory == null)
            {
                Assembly ass = GetAssembly();
                factory = ass.CreateInstance("System.Data.SQLite.SQLiteFactory");
                if (factory == null)
                {
                    throw new System.Exception("Can't Create  SQLiteFactory in System.Data.SQLite.dll");
                }
                else
                {
                    _Cache.Add("SQLite_Factory", factory, null, 10080);
                }

            }
            return factory as DbProviderFactory;

        }
        public override DbParameter GetNewParameter()
        {
            Assembly ass = GetAssembly();
            object para = ass.CreateInstance("System.Data.SQLite.SQLiteParameter");
            if (para == null)
            {
                throw new System.Exception("Can't Create  SQLiteParameter in System.Data.SQLite.dll");
            }
            else
            {
                return para as DbParameter;
            }
            //object para = _Cache.Get("SQLite_Parameter");
            //if (para == null)
            //{
            //    Assembly ass = GetAssembly();
            //    para = ass.CreateInstance("System.Data.SQLite.SQLiteParameter");
            //    if (para == null)
            //    {
            //        throw new System.Exception("Can't Create  SQLiteParameter in System.Data.SQLite.dll");
            //    }
            //    else
            //    {
            //        _Cache.Add("SQLite_Parameter", para, null, 10080);
            //    }
            //}
            //return para as DbParameter;

        }
    }
}
