using System;
using System.Collections.Generic;
using System.Text;

namespace CYQ.Data.SQL
{
    /// <summary>
    /// ṹ
    /// </summary>
    internal class ProcedureSql
    {
        private static StringBuilder sqlText = new StringBuilder();

        #region ȡݿֶ
        /// <summary>
        /// ݿⲻ˵ֶ
        /// </summary>
        /// <returns></returns>
        internal static string GetTableColumnsByMSSQL()
        {
            sqlText.Remove(0, sqlText.Length);
            sqlText.Append("select s1.name as ColumnName,case s2.name when 'nvarchar' then s1.[prec] WHEN 'uniqueidentifier' THEN 36 ");
            sqlText.Append("WHEN 'ntext' THEN -1 WHEN 'text' THEN -1 WHEN 'image' THEN -1 else s1.[length] end  as [MaxSize],");
            sqlText.Append("isnullable as [IsNullable],colstat as [ReadOnly],s2.name as [SqlType] ");
            sqlText.Append("from syscolumns s1 right join systypes s2 on s2.xtype =s1.xtype  ");
            sqlText.Append("where id=object_id(@TableName)  and s2.name<>'sysname' order by ReadOnly desc  ");
            //sqlText.Append("select substring(@@Version, 25,1)  ");
            return sqlText.ToString();
        }
        public static string GetTableColumnsByOracle(params string[] flag)
        {
            if (flag.Length > 0 && flag[0]=="p")
            {
                return @" select argument_Name as ColumnName,-1 as MaxSize,0 as IsNullable,0 as ReadOnly,'int' as SqlType from user_arguments where object_name=upper(:TableName)";
            }
            else
            {
                return @"select COLUMN_NAME as ColumnName,
                    Data_length*2 as MaxSize,
                    case NULLABLE when 'Y' then 1 else 0 end as IsNullable,
                    0 as ReadOnly,
                    DATA_TYPE as SqlType
                    from USER_TAB_COLS where TABLE_NAME=upper(:TableName) order by COLUMN_ID";
            }
        }
        /// <summary>
        /// Sql2005ݿ˵ֶ
        /// </summary>
        /// <returns></returns>
        //internal static string GetTableColumns2005()
        //{
        //    sqlText.Remove(0, sqlText.Length);
        //    sqlText.Append("select s1.name as ColumnName,case s2.name when 'nvarchar' then s1.[prec] else s1.[length] end  as [MaxSize],");
        //    sqlText.Append("isnullable as [IsNullable],colstat as [ReadOnly],s2.name as [SqlType] ,isnull(s3.[value],'no description') as description ");
        //    sqlText.Append("from syscolumns s1 right join systypes s2 on s2.xtype =s1.xtype  ");
        //    sqlText.Append("left join sys.extended_properties s3 on ( s3.minor_id = s1.colid and s3.major_id = s1.id) ");
        //    sqlText.Append("where id=object_id(@TableName)  and s2.name<>'sysname' order by ReadOnly desc  ");
        //    sqlText.Append("select substring(@@Version, 25,1)  ");
        //    return sqlText.ToString();
        //}
        /// <summary>
        /// Sql2000ݿ˵ֶ
        /// </summary>
        /// <returns></returns>
        //internal static string GetTableColumns2000()
        //{
        //    sqlText.Remove(0, sqlText.Length);
        //    sqlText.Append("select s1.name as ColumnName,case s2.name when 'nvarchar' then s1.[prec] else s1.[length] end  as [MaxSize],");
        //    sqlText.Append("isnullable as [IsNullable],colstat as [ReadOnly],s2.name as [SqlType] ,isnull(s3.[value],'no description') as description ");
        //    sqlText.Append("from syscolumns s1 right join systypes s2 on s2.xusertype =s1.xusertype  ");//б仯
        //    sqlText.Append("left join sysproperties s3 on  (s3.id=s1.id and s3.smallid = s1.colid)");//б仯
        //    sqlText.Append("where s1.id=object_id(@TableName)  and s2.name<>'sysname' order by ReadOnly desc  ");//б仯
        //    //sqlText.Append("select substring(@@Version, 25,1)  ");
        //    return sqlText.ToString();
        //}
        #endregion
        #region ־

        internal static string IsLogTableExist2000()
        {
            return "SELECT count(*) FROM sysobjects WHERE id = OBJECT_ID(N'[dbo].[ErrorLogs]') AND xtype in (N'U')";
        }
        internal static string IsLogTableExist2005()
        {
            return "SELECT count(*) FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[ErrorLogs]') AND type in (N'U')";
        }
        internal static string IsLogTableExistOracle()
        {
            return "Select count(*)  From user_objects Where object_type='TABLE' and object_name=upper('ErrorLogs')";
        }
        internal static string GetCreateLogTableSql()
        {
            return @"
    CREATE TABLE [dbo].[ErrorLogs](
	[ID] [int] IDENTITY(1,1) NOT NULL PRIMARY KEY,
	[PageUrl] [nvarchar](2000)  NULL,
	[ErrorMessage] [nvarchar](4000) NULL,
	[LogTime] [datetime] NULL  DEFAULT (getdate())
	)";
        }
        internal static string GetCreateLogTableSqlForOracle()
        {
            return @"create table ErrorLogs(ID number not null,PageUrl  nvarchar2(2000),ErrorMessage nvarchar2(4000),LogTime  date default sysdate,CONSTRAINT errorlogs_id_pk PRIMARY KEY (ID)) tablespace USERS";
        }
        #endregion

       
    }
}
