using System;
using System.Collections.Generic;
using System.Text;
using CYQ.Data.Table;
using CYQ.Data.DAL;

namespace CYQ.Data.SQL
{
    /// <summary>
    /// ݲ
    /// </summary>
    internal class SQLString
    {
        internal MDataRow _Row;
        private DbBase _DataSqlHelper;
        internal bool _IsCanDo = false;
        private string _TableName;
        private static string _AutoID = null;//oracle
        public static string AutoID
        {
            get
            {
                if (_AutoID == null)
                {
                    _AutoID = AppConfig.AutoID;
                    if (string.IsNullOrEmpty(_AutoID))
                    {
                        _AutoID = "AutoID";
                    }
                }
                return _AutoID;
            }
        }
        internal object[] _SelectColumns = null;//ѯָ
        public SQLString(ref MDataRow row, ref DbBase helper)
        {
            _DataSqlHelper = helper;
            SetRow(ref row);
        }
        public void SetRow(ref MDataRow row)
        {
            _Row = row;
            _TableName = row.TableName;
        }
        #region Sql

        #region ȡSQL

       
        internal string GetDeleteSql(object where)
        {
            return "delete  from " + _TableName + " Where " + FormatWhere(where);
        }
        /// <summary>
        /// زַ
        /// </summary>
        /// <returns>:insert into tableName(ID,Name,Value) values(@ID,@Name,@Value)</returns>
        internal string GetInsertSql()
        {
            _IsCanDo = true;
            StringBuilder _TempSql = new StringBuilder();
            StringBuilder _TempSql2 = new StringBuilder();
            _TempSql.Append("insert into " + _TableName + "(");
            _TempSql2.Append(") Values(");
            int groupID = DataType.GetGroupID(_Row[0]._CellStruct.SqlType);
            if (groupID == 0 && _Row[0].Value == null)//guid
            {
                _Row[0].Value = Guid.NewGuid();
            }
            int i = groupID;
            for (; i < _Row.Count; i++)
            {
                if (!_Row[i]._CellStruct.IsCanNull && _Row[i]._CellValue.IsNull)
                {
                    _DataSqlHelper.attachInfo.Append("<hr>error : " + _Row[i]._CellStruct.ColumnName + " can't be null");
                    _IsCanDo = false;
                    break;
                }
                if (_Row[i]._CellValue.IsChange && !_Row[i]._CellValue.IsNull)
                {
                    _TempSql.Append("[" + _Row[i]._CellStruct.ColumnName + "],");
                    _TempSql2.Append(_DataSqlHelper.Pre + _Row[i]._CellStruct.ColumnName + ",");
                    _DataSqlHelper.AddParameters(_DataSqlHelper.Pre + _Row[i]._CellStruct.ColumnName, _Row[i]._CellValue.Value, DataType.GetDbType(_Row[i]._CellStruct.ValueType), _Row[i]._CellStruct.MaxSize, System.Data.ParameterDirection.Input);
                }
            }
            switch (_DataSqlHelper.dalType)
            {
                case DalType.Oracle:
                    _TempSql = _TempSql.Replace("[", "").Replace("]", "");
                    _TempSql.Append(_Row[0]._CellStruct.ColumnName + ",");
                    _TempSql2.Append(AutoID + ".nextval,");
                    break;
                case DalType.MySql:
                    _TempSql = _TempSql.Replace("[", "`").Replace("]", "`");
                    break;
            }

            string sql = _TempSql.ToString().TrimEnd(',') + _TempSql2.ToString().TrimEnd(',') + ")";
            switch (_DataSqlHelper.dalType)
            {
                case DalType.Sql:
                    sql += (groupID == 1 ? " select cast(scope_Identity() as int) as OutPutValue" : string.Format(" select '{0}' as OutPutValue", _Row[0].Value));
                    break;
                //case DalType.Oracle:
                //    sql ="BEGIN "+sql+ string.Format(";select {0}.currval from dual; END;", autoID);
                //    break;
            }
            return sql;
        }
        /// <summary>
        /// زWhereַ
        /// </summary>
        /// <returns>:Update tableName set Name=@Name,Value=@Value</returns>
        internal string GetUpdateSql(object where)
        {
            _IsCanDo = true;
            StringBuilder _TempSql = new StringBuilder();
            _TempSql.Append("Update " + _TableName + " set ");
            for (int i = 1; i < _Row.Count; i++)
            {
                if (_Row[i]._CellValue.IsChange && (_Row[i]._CellStruct.IsCanNull || !_Row[i]._CellValue.IsNull))
                {
                    _DataSqlHelper.AddParameters(_DataSqlHelper.Pre + _Row[i]._CellStruct.ColumnName, _Row[i]._CellValue.Value, DataType.GetDbType(_Row[i]._CellStruct.ValueType), _Row[i]._CellStruct.MaxSize, System.Data.ParameterDirection.Input);
                    _TempSql.Append("[" + _Row[i]._CellStruct.ColumnName + "]=" + _DataSqlHelper.Pre + _Row[i]._CellStruct.ColumnName + ",");
                }
            }
            switch (_DataSqlHelper.dalType)
            {
                case DalType.Oracle:
                case DalType.SQLite:
                    _TempSql = _TempSql.Replace("[", "").Replace("]", "");
                    break;
                case DalType.MySql:
                    _TempSql = _TempSql.Replace("[", "`").Replace("]", "`");
                    break;
            }
            _TempSql = _TempSql.Remove(_TempSql.Length - 1, 1);
            _TempSql.Append(" where " + FormatWhere(where));
            return _TempSql.ToString();
        }
        internal string GetCountSql(string where)
        {
            if (!string.IsNullOrEmpty(where))
            {
                where = " where " + where;
            }
            where = RemoveOrderBy(where);
            return "select count(*) from " + _TableName + FormatWhere(where);
        }
        internal string GetTopOneSql(object where)
        {
            string columnNames = GetColumnsSql();//ָйܣ
            switch (_DataSqlHelper.dalType)
            {
                case DalType.Sql:
                case DalType.Access:
                    return "select top 1 " + columnNames + " from " + _TableName + " where " + FormatWhere(where);
                case DalType.Oracle:
                    return "select " + columnNames + " from " + _TableName + " where rownum=1 and " + FormatWhere(where);
                case DalType.SQLite:
                case DalType.MySql:
                    return "select " + columnNames + " from " + _TableName + " where " + FormatWhere(where) + " limit 1";
            }
            throw new Exception(string.Format("GetTopOneSql:{0} No Be Support Now!", _DataSqlHelper.dalType.ToString()));
        }
        internal string GetBindSql(string where, object text, object value)
        {
            if (!string.IsNullOrEmpty(where))
            {
                where = " where " + where;
            }
            return string.Format("select distinct {0},{1} from {2} {3}", text.ToString(), value.ToString(), _TableName, FormatWhere(where));
        }
        internal string GetMaxID()
        {
            switch (_DataSqlHelper.dalType)
            {
                case DalType.MySql:
                case DalType.SQLite:
                case DalType.Access:
                    return "select max(ID) from " + _TableName;
                case DalType.Oracle:
                    return string.Format("select {0}.currval from dual", AutoID);
            }
            throw new Exception(string.Format("GetMaxID:{0} No Be Support Now!", _DataSqlHelper.dalType.ToString()));
        }

        #endregion

        internal string RemoveOrderBy(string where)
        {
            int index = where.ToLower().IndexOf("order by");
            if (index > 0)
            {
                where = where.Substring(0, index);
            }
            return where;
        }
        internal string FormatWhere(object beFormatWhere)
        {
            string where = Convert.ToString(beFormatWhere);
            if (string.IsNullOrEmpty(where))
            {
                return "";
            }
            where = FormatDal(where.TrimEnd(), _DataSqlHelper.dalType, true);
            string lowerWhere = where.ToLower().TrimStart();
            if (lowerWhere.StartsWith("order by"))
            {
                where = "1=1 " + where;
            }
            else if (lowerWhere.IndexOfAny(new char[] { '=', '>', '<' }) == -1 && !lowerWhere.Contains(" like ") && !lowerWhere.Contains(" between ") && !lowerWhere.Contains(" in ") && !lowerWhere.Contains(" is "))
            {
                if (DataType.GetGroupID(_Row[0]._CellStruct.SqlType) == 1)//int ͵
                {
                    return _Row[0]._CellStruct.ColumnName + "=" + where;
                }
                return _Row[0]._CellStruct.ColumnName + "='" + where + "'";
            }

            return where;
        }
        #region ָӵ

        /// <summary>
        /// ڵ䣬ͬʱǰwhereǰãԭwhereֻorderby֡
        /// </summary>
        /// <param name="where"></param>
        /// <returns></returns>
        internal string GetSelectTableName(ref string where)
        {
            if (_TableName.IndexOf(')') > -1 || _SelectColumns == null || _SelectColumns.Length == 0)
            {
                return _TableName;
            }
            string whereOnly = string.Empty;
            if (!string.IsNullOrEmpty(where))
            {
                int orderbyIndex = where.ToLower().IndexOf("order by");
                if (orderbyIndex > -1)
                {
                    whereOnly = " where " + where.Substring(0, orderbyIndex - 1);//-1ȥո
                    where = "1=1 " + where.Substring(orderbyIndex);
                }
                else
                {
                    whereOnly = " where " + where;
                    where = string.Empty;
                }
            }
            return "(select " + GetColumnsSql() + " from " + _TableName + whereOnly + ") " + _TableName;
        }
        internal string GetColumnsSql()//Ӻָ
        {
            if (_SelectColumns == null || _SelectColumns.Length == 0)
            {
                return "*";
            }
            string v_Columns = string.Empty;
            foreach (object column in _SelectColumns)
            {
                v_Columns +=column + ",";
            }
            _SelectColumns = null;
            return v_Columns.TrimEnd(',');
        }
        #endregion

        #region غ

        
        internal static string FormatDal(string text, DalType dalType,bool filter)
        {
            if (filter)
            {
                text = FilterChar(text, dalType);
            }
            if (!string.IsNullOrEmpty(text))
            {
                text = ReplaceFunA(text, dalType);
                switch (dalType)
                {
                    case DalType.Access:
                        text = ReplaceValue(text, true);
                        text = ReplaceFunB(text, true);
                        text = ReplaceFunC(text, false);
                        break;
                    case DalType.Sql:
                        text = ReplaceValue(text, false);
                        text = ReplaceFunB(text, true);
                        text = ReplaceFunC(text, true);
                        break;
                    case DalType.Oracle:
                        text = ReplaceValue(text, false);
                        text = ReplaceFunB(text, false);
                        text = ReplaceFunC(text, false);
                        break;
                }
            }
            return text;
        }
        #region ɰϵͳ
        //public static string[] filterKey = { "select", "master", "delete", "drop", "update", "truncate", "create", "exists", "insert", "asc(", "while", "xp_cmdshell", "add", "declare", "exec", "ch", "ch(", "delay", "waitfor", "sleep" };

        //private static string FilterChar(string text)
        //{
        //    text = text.Replace("--", "").Replace(";", "").Replace("&", "").Replace("*", "").Replace("||", "");
        //    string lowerText = text.ToLower();
        //    string[] items = lowerText.Split(' ');
        //    if (items.Length == 1 && lowerText.Length > 30)
        //    {
        //        Log.WriteLog(text);//¼־
        //        if (text.IndexOf("%20") > -1)
        //        {
        //            return string.Empty;
        //        }
        //    }
        //    int keyIndex = -1;
        //    bool isOK = false;
        //    string tempKey = string.Empty;
        //    for (int i = 0; i < filterKey.Length; i++)
        //    {
        //        keyIndex = lowerText.IndexOf(filterKey[i]);
        //        if (keyIndex > -1)
        //        {
        //            foreach (string item in items) // createtime
        //            {
        //                tempKey = item.Trim('\'', ')', '|', '!', '%', '^', '(');
        //                if (tempKey.IndexOf(filterKey[i]) > -1 && tempKey.Length > filterKey[i].Length)
        //                {
        //                    isOK = true;
        //                    break;
        //                }
        //            }
        //            if (!isOK)
        //            {
        //                Log.WriteLog(filterKey[i] + text);//¼־
        //                return string.Empty;
        //            }
        //            else
        //            {
        //                isOK = false;
        //            }
        //        }
        //    }
        //    return text;

        //}
        #endregion

        #region °ϵͳ
        private static string[] filterKeyList = { "select;from", "select;into", "delete;from", "drop;table", "drop;database", "update;set", "truncate;table", "create;table", "exists;select", "insert;into", "asc(", "xp_cmdshell", "declare;@", "exec;master", "chr(", "ch(", "waitfor;delay" };
        public static string FilterChar(string text, DalType dalType)
        {
            text = text.Replace("--", "").Replace(";", "").Replace("&", "").Replace("*", "").Replace("||", "");
            string[] items = text.Split(' ');
            if (items.Length == 1 && text.Length > 30)
            {
                if (text.IndexOf("%20") > -1)
                {
                    Log.WriteLog(text);//¼־
                    return string.Empty;
                }
            }
            else
            {
                switch (dalType)
                {
                    case DalType.MySql:
                    case DalType.Oracle:
                    case DalType.SQLite:
                        for (int i = 0; i < items.Length; i++)//ȥֶε[ֶ]
                        {
                            if (!items[i].StartsWith("[#") && items[i].StartsWith("[") && items[i].EndsWith("]"))
                            {
                                text = text.Replace(items[i], items[i].Replace("[", string.Empty).Replace("]", string.Empty));
                            }
                        }
                        break;
                }
            }
            string lowerText = text.ToLower();
            items = lowerText.Split(' ');

            int keyIndex = -1;
            bool isOK = false;
            string tempKey = string.Empty;
            if (!string.IsNullOrEmpty(AppConfig.FilterSqlInjection))
            {
                filterKeyList = AppConfig.FilterSqlInjection.Split(',');
            }
            string filterKey = string.Empty;
            string[] filterSpitItems = null;
            for (int i = 0; i < filterKeyList.Length; i++)
            {
                filterSpitItems = filterKeyList[i].Split(';');//ָ
                filterKey = filterSpitItems[0];//ȡһΪؼ
                if (filterSpitItems.Length > 2)
                {
                    continue;
                }
                else if (filterSpitItems.Length == 2) // ʵġ
                {
                    keyIndex = Math.Min(lowerText.IndexOf(filterKey), lowerText.IndexOf(filterSpitItems[1]));
                }
                else
                {
                    keyIndex = lowerText.IndexOf(filterKey);//˵Ĺؼʻ
                }
                if (keyIndex > -1)
                {
                    foreach (string item in items) // ûÿһĴ
                    {
                        tempKey = item.Trim('\'', ')', '|', '!', '%', '^', '(');
                        if (tempKey.IndexOf(filterKey) > -1 && tempKey.Length > filterKey.Length)
                        {
                            isOK = true;
                            break;
                        }
                    }
                    if (!isOK)
                    {
                        Log.WriteLog(filterKeyList[i] + ":" + text);//¼־
                        return string.Empty;
                    }
                    else
                    {
                        isOK = false;
                    }
                }
            }
            return text;

        }
        #endregion

        private static string ReplaceValue(string text, bool access)
        {
            return access ? text.Replace(DalValue.True, "true").Replace(DalValue.False, "false").Replace(DalValue.Desc, "asc").Replace(DalValue.Asc, "desc") : text.Replace(DalValue.True, "1").Replace(DalValue.False, "0").Replace(DalValue.Desc, "desc").Replace(DalValue.Asc, "asc");
        }
        private static string ReplaceFunA(string text, DalType dalType)
        {
            text = FormatDateDiff(text, dalType);//滻֮ǰ
            text = FormatCaseWhen(text, dalType);
            switch (dalType)
            {
                case DalType.Access:
                case DalType.Sql:
                    return text.Replace(DalValue.Len, "len").Replace(DalValue.Substring, "substring").Replace(DalValue.GetDate, (dalType == DalType.Access ? "now()" : "getdate()"));
                case DalType.Oracle:
                    return text.Replace(DalValue.Len, "length").Replace(DalValue.Substring, "substr").Replace(DalValue.GetDate, "to_char(current_date,'dd-mon-yyyy hh:mi:ss')");
            }
            return text;
        }
        private static string ReplaceFunB(string text, bool AorS)//ظֵؼٲ
        {
            text = FormatDate(text, AorS, DalValue.Year, ",'yyyy'", "Year");
            text = FormatDate(text, AorS, DalValue.Month, ",'MM'", "Month");
            text = FormatDate(text, AorS, DalValue.Day, ",'dd'", "Day");
            return text;
        }
        private static string FormatDate(string text, bool AorS,string key,string format,string func)
        {
            int index = text.IndexOf(key);
            if (index > -1)//year
            {
                if (!AorS)
                {
                    int found = 0;
                    do
                    {
                        text = text.Insert(index + 2, "_");
                        found = text.IndexOf(')', index + 4);
                        text = text.Insert(found, format);
                        index = text.IndexOf(key);
                    }
                    while (index > -1);
                    text = text.Replace("#_", "#");
                }
                text = AorS ? text.Replace(key, func) : text.Replace(key, "to_char");
            }
            return text;
        }
        private static string ReplaceFunC(string text, bool sql)
        {
            return FormatCharIndex(text, sql, DalValue.CharIndex);
        }
        public static string FormatCharIndex(string text, bool sql, string key)
        {
            //select [#charindex]('ok',xxx) from xxx where [#charindex]('ok',xx)>0
            int index = text.IndexOf(key);
            if (index > -1)//charIndex
            {
                if (!sql)
                {
                    int found = 0;
                    string func = string.Empty;
                    do
                    {
                        int start = index + key.Length;
                        text = text.Insert(index + 2, "_");//select [#_charindex]('ok',xxx) from xxx where [#charindex]('ok',xx)>0
                        found = text.IndexOf(')', index + 4);
                        func = text.Substring(start + 2, found - start - 2);
                        string[] funs = func.Split(',');
                        text = text.Remove(start + 2, found - start - 2);//Ƴ//select [#_charindex]() from xxx where [#charindex]('ok',xx)>0
                        text = text.Insert(start + 2, funs[1] + "," + funs[0]);
                        index = text.IndexOf(key);
                    }
                    while (index > -1);
                    text = text.Replace("#_", "#");
                }
                text = sql ? text.Replace(key, "CHARINDEX") : text.Replace(key, "instr");
            }
            return text;
        }
        public static string FormatDateDiff(string text, DalType dalType)
        {
            string key = DalValue.DateDiff;
            //select [#DATEDIFF](aa,'bb','cc') from xxx where [#DATEDIFF](aa,'bb','cc')>0
            int index = text.IndexOf(key);
            if (index > -1)//'yyyy','q','m','y','d','ww','hh/h','n','s'
            {
                text = text.Replace(key, "DateDiff");
                string[] keys = new string[] { "yyyy", "q", "m", "y", "d", "h", "ww", "n", "s" };//"hh/h"
                switch (dalType)
                {
                    case DalType.Access:
                        text = text.Replace(DalValue.GetDate, "now()");
                        foreach (string key1 in keys)
                        {
                            text = text.Replace("[#" + key1 + "]", "'" + key1 + "'");
                        }
                        break;
                    case DalType.Sql:
                        text = text.Replace("[#h]", "hh");
                        text = text.Replace(DalValue.GetDate, "getdate()");
                        foreach (string key2 in keys)
                        {
                            text = text.Replace("[#" + key2 + "]", key2);
                        }
                        break;
                    case DalType.Oracle:
                        text = text.Replace(DalValue.GetDate, "sysdate");
                        foreach (string key3 in keys)
                        {
                            text = text.Replace("[#" + key3 + "]", "'" + key3 + "'");
                        }
                        break;
                }
            }
            return text;
        }
        public static string FormatCaseWhen(string text, DalType dalType)
        {
            //CASE when languageID=1 THEN 1000 ELSE 10 End

            switch (dalType)
            {
                case DalType.Sql:
                case DalType.Oracle:
                    if (text.IndexOf(DalValue.Case) > -1 || text.IndexOf(DalValue.CaseWhen) > -1)
                    {
                        text = text.Replace(DalValue.Case, "Case").Replace(DalValue.CaseWhen, "Case When").Replace("[#WHEN]", "when").Replace("[#THEN]", "then").Replace("[#ELSE]", "else").Replace("[#END]", "end");
                    }
                    break;
                case DalType.Access:
                    if (text.IndexOf(DalValue.Case) > -1)
                    {
                        text = text.Replace(DalValue.Case, string.Empty).Replace("[#WHEN]", "iif(").Replace("[#THEN]", ",").Replace("[#ELSE]", ",").Replace("[#END]", ")");
                    }
                    else if (text.IndexOf(DalValue.CaseWhen) > -1)
                    {
                        text = text.Replace(DalValue.CaseWhen, "SWITCH(").Replace("[#THEN]", ",").Replace("[#ELSE]", "TRUE,").Replace("[#END]", ")");
                    }
                    break;
            }

            return text;
        }

        #endregion
        #endregion
    }
}
