using System;
using System.Collections.Generic;
using System.Text;
using CYQ.Data.Table;
using CYQ.Data.DAL;
using System.Data.Common;
using System.Data;

namespace CYQ.Data.SQL
{
    /// <summary>
    /// ṹ
    /// </summary>
    internal class SchemaAction
    {
        internal static MDataColumn GetColumn(string tableName, ref DbBase helper)
        {
            MDataColumn mdcs = new MDataColumn();
            CellStruct mStruct = null;
            DalType dalType = helper.tempSql == "view" ? DalType.Access : helper.dalType;
            switch (dalType)
            {
                case DalType.Sql:
                case DalType.Oracle:
                    string sql = helper.dalType == DalType.Sql ? GetMSSQLColumns() : GetOracleColumns();
                    helper.AddParameters("TableName", tableName, DbType.String, 50, ParameterDirection.Input);
                    DbDataReader sdr = helper.ExeDataReader(sql, false);
                    if (sdr != null)
                    {
                        while (sdr.Read())
                        {
                            mStruct = new CellStruct(sdr["ColumnName"].ToString(), DataType.GetSqlType(sdr["SqlType"].ToString()), Convert.ToBoolean(sdr["ReadOnly"]), Convert.ToBoolean(sdr["IsNullable"]), Convert.ToInt32(sdr["MaxSize"]), ParameterDirection.InputOutput);
                            mdcs.Add(mStruct);

                        }
                        sdr.Close();
                    }
                    break;
                case DalType.MySql:
                case DalType.SQLite:
                case DalType.Access:
                    DataTable dt = helper.ExeDataTable(string.Format("select * from {0} where 1=2", tableName), false);
                    if (dt != null)
                    {
                        foreach (DataColumn dc in dt.Columns)
                        {
                            mStruct = new CellStruct(dc.ColumnName, DataType.GetSqlType(dc.DataType), dc.ReadOnly, dc.AllowDBNull, dc.MaxLength, ParameterDirection.InputOutput);
                            mdcs.Add(mStruct);
                        }

                    }
                    break;
            }
            helper.ClearParameters();
            return mdcs;
        }
        #region ȡݿֶ

        internal static string GetMSSQLColumns()
        {
            return @"select s1.name as ColumnName,case s2.name when 'nvarchar' then s1.[prec] WHEN 'uniqueidentifier' THEN 36 
                     WHEN 'ntext' THEN -1 WHEN 'text' THEN -1 WHEN 'image' THEN -1 else s1.[length] end  as [MaxSize],
                     isnullable as [IsNullable],colstat as [ReadOnly],s2.name as [SqlType] 
                     from syscolumns s1 right join systypes s2 on s2.xtype =s1.xtype  
                     where id=object_id(@TableName)  and s2.name<>'sysname' order by ReadOnly desc,s1.colid asc";
        }
        public static string GetOracleColumns()
        {
            return @"select COLUMN_NAME as ColumnName,
                    Data_length*2 as MaxSize,
                    case NULLABLE when 'Y' then 1 else 0 end as IsNullable,
                    0 as ReadOnly,
                    DATA_TYPE as SqlType
                    from USER_TAB_COLS where TABLE_NAME=upper(:TableName) order by COLUMN_ID";
        }

        #endregion



    }
}
