﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using CYQ.Data;
using CYQ.Entity.MySpace;
public partial class SetSelectColumn : System.Web.UI.Page
{
    object[] selectColumns = null;
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            BindData();
        }
    }
    protected void BindData()
    {
        int count;
        using (MAction action = new MAction(TableNames.Blog_Class))
        {
            action.SetSelectColumns(selectColumns);//指定列
            action.Select(Pager1.PageIndex, Pager1.PageSize, string.Empty, out count).Bind(gvClass);
            Pager1.Count = count;
            Pager1.BindName = "BindData";
        }
    }
    protected void btnQuery_Click(object sender, EventArgs e)
    {
        if (!string.IsNullOrEmpty(txtSelectColumns.Text))
        {
            selectColumns = txtSelectColumns.Text.Trim().Split(',');
            BindData();
        }
    }
    protected void btnInsert_Click(object sender, EventArgs e)
    {
        using (MAction action = new MAction(TableNames.Blog_Class))
        {
            action.SetAutoPrefix("txt");
            if (action.Insert(true))
            {
                action.Close();//在using内部return或跳转时，先关闭链接
                Response.Redirect(Request.RawUrl);
            }
        }
    }
    protected void btnUpdate_Click(object sender, EventArgs e)
    {
        using (MAction action = new MAction(TableNames.Blog_Class))
        {
            action.SetAutoPrefix("txt");
            if (action.Update(txtID.Text, true))
            {
                action.Close();//在using内部return或跳转时，先关闭链接
                Response.Redirect(Request.RawUrl);
            }
        }
    }
    protected void btnDelete_Click(object sender, EventArgs e)
    {
        using (MAction action = new MAction(TableNames.Blog_Class))
        {
            action.SetAutoPrefix("txt");
            if (action.Delete(txtID.Text))
            {
                action.Close();//在using内部return或跳转时，先关闭链接
                Response.Redirect(Request.RawUrl);
            }
        }
    }
    protected void btnFill_Click(object sender, EventArgs e)
    {
        using (MAction action = new MAction(TableNames.Blog_Class))
        {
            action.SetSelectColumns(Class.PKey,Class.Name,Class.Description);//指定列查询
            if (action.Fill(txtID.Text))
            {
                action.SetTo(txtPKey);
                action.SetTo(txtName);
                action.SetTo(txtDescription);
            }
        }
    }
}
